/******************************************************************************/
/* System Level #define Macros                                                */
/******************************************************************************/

// pin asignment
#define outLEDgreenPin          GPIObits.GP1
#define outLEDredPin            GPIObits.GP4
#define in0crossingPin          GPIObits.GP0
#define	inLearnButtonPin	GPIObits.GP3
#define	outRelaisPin		GPIObits.GP5

// constants
#define LearnButtonPressed 0    // switch attached to GND
#define RelaisOn 1
#define RelaisOff 0
#define const_ADCsamples 4


#define _XTAL_FREQ 4000000  // internal OSC, 4MHz

#define ENABLE_AC_ZERO_DEDECTION   // define this to add the zero crossing code (or comment to remove this code)
// Operate Time: 15...20 ms ?
#define RelaisOn_delay_mikrosec 3000    // turn relais on: 30 ms - 27 ms = 3 ms (old value 9 ms)
// Release Time: 8..10 ms max.?
#define RelaisOff_delay_mikrosec 100   // swith relais off: 10 ms - 9.9 ms = 0.1 ms (old value 1.9 ms)

/******************************************************************************/
/* System Function Prototypes                                                 */
/******************************************************************************/

/* Custom oscillator configuration funtions, reset source evaluation
functions, and other non-peripheral microcontroller initialization functions
go here. */

void ConfigureOscillator(void); /* Handles clock switching/osc initialization */
