/******************************************************************************/
/* Files to Include                                                           */
/******************************************************************************/

#include <xc.h>         /* XC8 General Include File */

#include <stdint.h>         /* For uint8_t definition */
#include <stdbool.h>        /* For true/false definition */

#include "user.h"


/******************************************************************************/
/* User Functions                                                             */
/******************************************************************************/

/* <Initialize variables in user.h and insert code for user algorithms.> */

void InitApp(void)
{
    /* Initialize User Ports/Peripherals/Project here */

    /* Setup analog functionality and port direction */
    TRISIO = 0b00001101; // Setze GP0,GP2,GP3 als Eingang und GP1,GP4,GP5 als Ausgang

    OPTION_REG = 0b10000101;    // GPIO pull-ups disabled, internen Takt zhlen, Vorteiler zum Timer0, 1:64

    TMR0 = const_timer0; // 125 Hz-Timer-Interupt einstellen

    GPIO = 0x00;
    ADON = 1;   // ADC einschalten
    // group by memory bank, to avoid unessary "select bank n" assembler statements!

    /* Initialize peripherals */
    CMCON = 0b00000111;  // Komperator ausschalten (GP0..GP2)
    ADFM = 1;   // ADC Daten rechtsbndig
    ANSELbits.ANS0 = 0;   // set as digial I/O
    ANSELbits.ANS1 = 0;   // set as digial I/O
    ANSELbits.ANS2 = 1;   // set as analog in
    ANSELbits.ANS3 = 0;   // set as digial I/O
    ANSELbits.ADCS = 0b101; // A/D speed F OSC/16


    /* Enable interrupts */
    IOCbits.IOC0 = 1;   // allow interrupt on change @GP0
    INTCONbits.T0IE = 1;    // Timer0 interupt erlauben
//    ei(); // enable all interrupts
    di(); // disable all interrupts

}

/* run ADC and wait for completion */
void adc_read(void)
{
    ADCON0bits.GO = 1;  // start conversion
    while (ADCON0bits.GO_nDONE) // wait until done
        ;
}


/* zero crossing function */
//void detect_AC_zero(void)
//{
//    unsigned int ADCresult_old;
//    // to store the ADC result values
//    union {unsigned int ADRES;
//        unsigned char ad_hi_low[2];
//    } ADCout;
//
//    char AC_wave=increasing;
//    char wait_counter=3;
//
//    while (wait_counter > 0 && AC_wave != decreasing)
//    {
//        ADCON0bits.CHS = 0b00;    // select Analog Channel AN0
//        _delay(16); // wait 16 cycles (1/(4MHz/4) = 1s * 16 = 16 s
//        adc_read();
//        ADCout.ad_hi_low[0] = ADRESL;
//        ADCout.ad_hi_low[1] = ADRESH;
//
//
//        if (ADCout.ADRES < ADCresult_old)   //
//        {
//            --wait_counter;
//        }
//
//        ADCresult_old = ADCout.ADRES;   // save old value for next comparison
//    }
//
//}